diff a/src/java.base/share/native/libjli/java.h b/src/java.base/share/native/libjli/java.h
--- a/src/java.base/share/native/libjli/java.h
+++ b/src/java.base/share/native/libjli/java.h
@@ -71,10 +71,17 @@
 
 #define SPLASH_FILE_ENV_ENTRY "_JAVA_SPLASH_FILE"
 #define SPLASH_JAR_ENV_ENTRY "_JAVA_SPLASH_JAR"
 #define JDK_JAVA_OPTIONS "JDK_JAVA_OPTIONS"
 
+#ifdef INCLUDE_TSAN
+typedef void (*TsanSymbolizeAddFrameFunc)(
+    void *ctx, const char *function, const char *file, int line, int column);
+typedef void (JNICALL *TsanSymbolize_t)(uint64_t, TsanSymbolizeAddFrameFunc, void *);
+extern TsanSymbolize_t tsan_symbolize_func;
+#endif
+
 /*
  * Pointers to the needed JNI invocation API, initialized by LoadJavaVM.
  */
 typedef jint (JNICALL *CreateJavaVM_t)(JavaVM **pvm, void **env, void *args);
 typedef jint (JNICALL *GetDefaultJavaVMInitArgs_t)(void *args);
@@ -82,10 +89,13 @@
 
 typedef struct {
     CreateJavaVM_t CreateJavaVM;
     GetDefaultJavaVMInitArgs_t GetDefaultJavaVMInitArgs;
     GetCreatedJavaVMs_t GetCreatedJavaVMs;
+#ifdef INCLUDE_TSAN
+    TsanSymbolize_t TsanSymbolize;
+#endif
 } InvocationFunctions;
 
 JNIEXPORT int JNICALL
 JLI_Launch(int argc, char ** argv,              /* main argc, argc */
         int jargc, const char** jargv,          /* java args */
